#!/bin/bash

#Authors: Cem Uluyazi, Peter Kuchar
#Date: dec.2010
#
#########################################
##PURPOSE OF THIS SCRIPT IS TO FIND UNUSED SERVICES IN rulebases_5_0.fws FILE. IT FIRST GENERATES COPIES
## OF objects_5_0.C AND rulebases_5_0.fws FILES, AND JUST WORKS ON THESE COPIES. DOES NOT MODIFY THESE FILES
## OR KEEPS THEM BUSY. THEN IT GENERATES THE UID LISTS AND THE SERVICE GROUP OBJECT CONTENTS FROM objects_5_0.C.
## AFTERWARDS SEARCHES THE UIDS FIRST IN THE RULEBASE THEN IN THE SERVICE GROUP OBJECT CONTENTS.
#########################################

## MAKE A TEMP FILE OF objects_5_0.C TO WORK ON
cp objects_5_0.C actual_short_objects.temp

## FIRST EXTRACT UNNECESSARY WORDS TO CLEAN THE FILE
grep -v -f extracted_lines_list.txt actual_short_objects.temp > actual_short_objects.temp2
## FIRST REMOVE IF THERE IS ANY
ls service_objects_list.txt >/dev/null 2>&1 && rm service_objects_list.txt >/dev/null 2>&1

## REMOVE PARENTHESES
sed 's/(service_group)/service_group/' actual_short_objects.temp2 | \
sed 's/(group)/group/' > actual_short_objects.temp3

## GET THE CONTENT OF SERVICE GROUP FOR EACH GROUP UID
## FIND LINE NO OF ":ClassName service_group", SUBTRACTING 3 GIVES THE STARTING LINE NO OF GROUPS
## AFTERWARDS GET CONTENT FROM STARTING LINE NO TO THE FIRST MATCH OF ":type group"

echo "Getting the contents of service groups."
for each in `awk '{lines[NR] = $0}/:ClassName service_group/{print NR}' actual_short_objects.temp3`
 do
        line_start=`expr $each - 3`
        echo "Line number: $line_start"
sed -n  "$line_start,/:type group/p" actual_short_objects.temp3 >> service_objects_list.txt
done
echo "Finished getting the contents of service group objects."

############ GET ALL UIDS FOR VARIOUS SERVICES
## FIRST REMOVE IF THERE IS ANY
ls service_names_uids_list.txt >/dev/null 2>&1 && rm service_names_uids_list.txt >/dev/null 2>&1

echo "Getting the necessary service uids."

##SERVICES BELOW ARE SEARCHED, SERVICES WHICH NEED NOT TO BE SEARCHED CAN BE COMMENTED OUT
grep -B3 ":ClassName (tcp_service)" actual_short_objects.temp3 > service_names_uids_list.txt
grep -B3 ":ClassName (udp_service)" actual_short_objects.temp3 >> service_names_uids_list.txt
grep -B3 ":ClassName (other_service)" actual_short_objects.temp3 >> service_names_uids_list.txt
grep -B3 ":ClassName service_group" actual_short_objects.temp3 >> service_names_uids_list.txt
grep -B3 ":ClassName (rpc_service)" actual_short_objects.temp3 >> service_names_uids_list.txt
grep -B3 ":ClassName (icmp_service)" actual_short_objects.temp3 >> service_names_uids_list.txt

## GET ONLY UIDS & REMOVE PUNCTUATION & SPACES
cat service_names_uids_list.txt | grep chkpf_uid | sed s/:chkpf_uid// | sed s/\(\"{// | sed s/}\"\)// \
 | awk '{ sub(/^[ \t]+/, ""); print }' > services_uids_list.txt

echo "Generated the uid lists."

############ SEARCH FOR UNUSED UIDS IN THE RULEBASE
## MAKE A TEMP FILE OF rulebases_5_0.fws TO WORK ON
cp rulebases_5_0.fws rulebases_5_0.fws.temp

echo "Searching for unused  service uids in the rulebase, this may take a while."

## FIRST REMOVE IF THERE IS ANY
ls service_unused_list1.txt >/dev/null 2>&1 && rm service_unused_list1.txt >/dev/null 2>&1

for object in `less services_uids_list.txt`
   do
        grep -q -m 1 $object rulebases_5_0.fws.temp || echo $object >> service_unused_list1.txt
   done

echo "Finished searching unused service uids in the rulebase."

############ SEARCH FOR UNUSED UIDS IN GROUPS

echo "Searching for unused uids in service groups."

## FIRST REMOVE IF THERE IS ANY
ls service_unused_list2.txt >/dev/null 2>&1 && rm service_unused_list2.txt >/dev/null 2>&1

for object in `less service_unused_list1.txt`
   do
        grep -q -m 1 $object service_objects_list.txt || echo $object >> service_unused_list2.txt
   done

echo "Finished searching unused services, generating the final list."

############ GETTING THE NAMES OF FINAL UNUSED SERVICES
## FIRST REMOVE IF THERE IS ANY
ls service_unused_list_final.txt >/dev/null 2>&1 && rm service_unused_list_final.txt >/dev/null 2>&1

for unused_object in `less service_unused_list2.txt`
   do
      	grep -B2 $unused_object service_names_uids_list.txt >> service_unused_list_final.txt
   done

## CLEANUP TEMP FILES
rm actual_short_objects.temp
rm actual_short_objects.temp2
rm actual_short_objects.temp3
rm rulebases_5_0.fws.temp
rm service_objects_list.txt
rm service_names_uids_list.txt
rm service_unused_list1.txt
rm services_uids_list.txt
rm service_unused_list2.txt
echo "Thank you for using our script, Cem & Peter"
